<?php 
require_once("php/staticContentGraff.php");
?>
<!DOCTYPE HTML>
<html>
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<title><? staticContentGraff::title(" - Preguntas y Respuestas"); ?></title>

<!-- Estilos en CSS-->
<link href="css/main.css" rel="stylesheet" type="text/css" media="screen"/>
<link href="css/index.css" rel="stylesheet" type="text/css" media="screen"/>

</head>
<body onload="checkError()">
	<header>
		<h1><a href="index.php" title="Home"><? staticContentGraff::title(); ?></a></h1>
	</header>
	
	<section id="faqmenu">
		<header>
			<h2>Preguntas y Respuestas</h2>
		</header>
		<ol>
			<li><a href="#tiposArchivos" title="¿Qué tipos de archivo usa Graff?">¿Qué tipos de archivo usa Graff?</a></li>
			<li><a href="#estructuraTabla" title="¿Qué estructura debe tener la tabla con mis datos?">¿Qué estructura debe tener la tabla con mis datos?</a></li>
			<li>
				<a href="#importarDatos" title="¿Cómo importo los datos...">¿Cómo importo los datos...</a>
				<ul>
					<li><a href="#desdeArchivo" title="... desde un Archivo?">... desde un Archivo?</a></li>
					<li><a href="#desdeGoogle" title="... desde Google Docs?">... desde Google Docs?</a></li>
				</ul>	
			</li>
			<li><a href="#despuesImportar" title="¿Qué hacer después de subir mis datos?">¿Qué hacer después de subir mis datos?</a></li>
			<li><a href="#areaTablas" title="Área de Trabajo de Tablas">Área de Trabajo de Tablas</a></li>
			<li><a href="#areaDiagramas" title="Área de Trabajo de Diagramas">Área de Trabajo de Diagramas</a></li>
		</ol>
	</section>
	
	<section id="faqspace">
		<h3 id="tiposArchivos">1º) ¿Qué tipos de archivo usa Graff?</h3>
			<p>Graff puede reconocer datos a partir de los siguientes tipos de fichero:</p>
			<ul>
				<li><a href="http://office.microsoft.com/es-es/excel-help/CL010057150.aspx" target="_blank" title="Más información sobre archivos .xls" style="text-decoration: line-through;">Hojas de cálculo de la suite Microsoft Office (.xls)</a></li>
				<li><a href="" target="_blank" title="Más información sobre archivos .ods">Hojas de cálculo de la suite Open Office (.ods)</a></li>
				<li><a href="" target="_blank" title="Más información sobre archivos .csv">Ficheros "Comma Separated Value" (.csv)</a></li>
				<li><a href="" target="_blank" title="Más información sobre archivos .txt">Ficheros de texto plano (.txt)</a></li>
			</ul>
			<p>También se pueden incorporar datos a partir de <a href="" title="Más información sobre Google SpreadSheets">hojas de cálculo online de Google Docs</a></p>
			
		<h3 id="estructuraTabla">2º) ¿Qué estructura debe tener la tabla con mis datos?</h3>
			<p>Es muy importante que las tablas se encuentren en alguno de los dos formatos soportados para obtener unas gráficas correctas.</p>
			<table id="formato1">
				<caption>Formato válido fila y columna</caption>
				<tr>
					<th>CELDA VACÍA</th>
					<th>TÍTULO A</th>
					<th>TÍTULO B</th>
					<th>...</th>
				</tr>
				<tr>
					<th>TÍTULO 1</th>
					<td>DATOS A1</td>
					<td>DATOS B1</td>
					<td>...</td>
				</tr>
				<tr>
					<th>TÍTULO 2</th>
					<td>DATOS A2</td>
					<td>DATOS B2</td>
					<td>...</td>
				</tr>
				<tr>
					<th>...</th>
					<td>...</td>
					<td>...</td>
					<td>...</td>
				</tr>
			</table>
			<table id="formato2">
				<caption>Formato válido columna</caption>
				<tr>
					<th>TÍTULO 1</th>
					<td>DATOS A1</td>
					<td>DATOS B1</td>
					<td>...</td>
				</tr>
				<tr>
					<th>TÍTULO 2</th>
					<td>DATOS A2</td>
					<td>DATOS B2</td>
					<td>...</td>
				</tr>
				<tr>
					<th>...</th>
					<td>...</td>
					<td>...</td>
					<td>...</td>
				</tr>
			</table>
			
			<p>Graff, en el caso de que hubiera algún error soportado, te ofrece la posibilidad de <a href="#" title="Área de trabajo de las tablas">editar las tablas</a> subidas para evitar retocar el archivo fuente y subirlo de nuevo.</p>
			<p>Los errores soportados más comunes son la existencia de celdas vacías o con valores no numéricos en mitad de la tabla, dónde debería haber un valor numérico. Para solucionar este problema rellena esas celdas con ceros o con el valor numérico adecuado. Puedes usar el botón "Arreglar conflictos" para rellenar automáticamente todas esas celdas con el valor cero.</p>

		<h3 id="importarDatos">3º) ¿Cómo importo los datos...</h3>
			<h4 id="desdeArchivo">... desde un Archivo?</h4>
			<p>Una vez tengas tu archivo listo, sólo tienes que seguir los siguentes pasos para subirlo:</p>
			<ul>
				<li>
					<span>Desde la página principal de Graff, haz click en el botón Seleccionar archivo</span><br />
					<img src="images/Ayuda_html_m26d432e7.jpg" />
				</li>
				<li>
					<span>Busca tu fichero en la ventana emergente que aparecerá y haz doble click sobre él para seleccionarlo</span><br />
					<img src="images/Ayuda_html_6301bee.jpg" />
				</li>
				<li>
					<span>Si has seleccionado el archivo correcto haz click en Cargar Datos</span><br />
					<span>Si te has equivocado y quieres seleccionar otro, haz click en Borrar</span>
					<img src="images/Ayuda_html_69e70e6a.jpg" />
				</li>
			</ul>
			<h4 id="desdeGoogle">... desde Google Docs?</h4>
			<ul>
				<li>
					<span>Desde la página de tu documento Google SpreadSheet haz click, dentro de las opciones de "Compartir", en "Publicar como página web"</span><br />
					<img src="images/Ayuda_html_f4fsd5.jpg" />
				</li>
				<li>
					<span>Selecciona que se publiquen todas las hojas o sólo la que necesites y haz click en "Iniciar la publicación".</span><br />
					<img src="images/Ayuda_html_df54fds7.jpg" />
				</li>
				<li>
					<span>Selecciona que el enlace publicado sea de tipo "Página web", copia dicho enlace y pégalo en el formulario de Graff.</span><br />
					<img src="images/Ayuda_html_87fasd4.jpg" />
				</li>
				<li>
					<span>Si has seleccionado el archivo correcto haz click en Cargar Datos</span><br />
					<span>Si te has equivocado y quieres seleccionar otro, haz click en Borrar</span>
					<img src="images/Ayuda_html_69e70e6a.jpg" />
				</li>
			</ul>

		<h3 id="despuesImportar">4º) ¿Qué hacer después de subir mis datos?</h3>
			<p>Una vez importados los datos con éxito, la pantalla principal de Graff se dividirá en dos mitades.
			A la izquierda un área de trabajo donde se mostrarán tus tablas junto a las opciones de edición de las mismas.
			Y a la derecha está el área del diagrama asociado a la tabla que se muestra en el área de tablas. También tendrás acceso en este área a las opciones de diseño del diagrama y a las herramientas de exportación.</p>
			<br />
			<p>Si hay algún error se mostrará un mensaje informando de ello y por defecto se mostrará sólo el área de trabajo de las tablas, para que soluciones todos los conflictos detectados.</p>
			<br />
			<p>Con los botones de la parte superior derecha puedes cambiar el modo de vista:</p>
				<p>Para ver ambas áreas</p>
				<img src="images/Ayuda_html_m69d5f788.jpg" />
				<p>Para ver sólo el área de tabla</p>
				<img src="images/Ayuda_html_m6c3782.jpg" />
				<p>Para ver sólo el área de diagrama</p>
				<img src="images/Ayuda_html_29b8cfc8.jpg" />
		
		<h3 id="areaTablas">5º) Área de Trabajo de Tablas</h3>
			<p>En el área de tabla se mostrarán las tablas que se encuentran en tu archivo y te permite manipularlas a tu antojo.</p>
			<h5>Acciones del área de tabla.</h5>
			<p>Abrir <a href="#contextoedicion" title="Ver más información">el contexto de edición</a>.</p>
			<img src="images/Ayuda_html_m20b8996d.jpg" />
			<p><a href="#formato1" title="Ver este ejemplo">Marcar la primera fila y la primera columna</a> como cabeceras de datos.</p>
			<img src="images/Ayuda_html_m43fa51e8.jpg" />
			<p><a href="#formato2" title="Ver este ejemplo">Marcar sólo la primera columna</a> como cabecera de datos.</p>
			<img src="images/Ayuda_html_33ddca6f.jpg" />
	
			<h5 id="contextoedicion">Contexto de edición.</h5>
			<p>El contexto de edición te permite manipular los datos de la tabla añadiendo o eliminando filas y columnas o editando el contenido de las celdas.</p>
			<p>Una vez realizados los cambios puedes, si estás en el modo para ver ambas áreas, "Refrescar" el diagrama con los nuevos datos.</p>
			<img src="images/Ayuda_html_174f6f23.jpg" />
			<p>También puedes "Guardar y Salir" del contexto de edición para seguir trabajando con otras tablas o con el diagrama;</p>
			<img src="images/Ayuda_html_5537101e.jpg" />
			<p>o "Salir sin guardar", para descartar todos los cambios que hayas realizado.</p>
			<img src="images/Ayuda_html_m3bf89af5.jpg" />
			<p>Si la tabla modificada, en el primer caso, o la original, en el segundo, presenta alguna celda con errores, no se podrá abandonar el contexto de edición hasta corregirlos todos.</p>

		<h3 id="areaDiagramas">6º) Área de Trabajo de Diagramas</h3>
			<p>En el área de diagrama podrás seleccionar las opciones de diseño del diagrama y podrás exportarlo como imagen o como HTML incrustado.</p>
			<h5>Acciones del área de diagrama</h5>
					<p>Guardar el diagrama en formapto .png. Se abrirá un mensaje con la imagen del diagrama y podrás guardarla haciendo click con el botón derecho y después "Guardar como...".</p>
					<img src="images/Ayuda_html_m4046641c.jpg" />
					<p>Exportar el diagrama en código HTML para incrustarlo en tu página web. Se abrirá un mensaje con el código HTML, que podrás seleccionar y copiar para llevártelo dónde necesites.</p>
					<img src="images/Ayuda_html_91829db.jpg" />
			<h5>Opciones de diagrama</h5>
			<p>En el panel podrás seleccionar varias opciones para adaptar el diagrama a tus necesidades.</p>
			<ul>
				<li>
					<p>Graff ofrece los siguientes tipos de diagramas:</p>
					<ul>
						<li>Diagrama de puntos</li>
						<li>Diagrama de líneas</li>
						<li>Diagrama de áreas</li>
						<li>Diagrama de barras</li>
						<li>Diagrama red</li>
						<li>Diagrama pastel</li>
						<li>Diagrama de barras laterales</li>
					</ul>
					<p>Existen las siguientes variantes de los tipos normales:</p>
					<ul>
						<li>Diagramas tipo Stacked</li>
						<li>Diagramas tipo Mini</li>
					</ul>
				</li>
				<li>Temas de colores: podrás cambiar la combinación de colores utilizada en el diagrama.</li>
				<li>Dimensiones del diagrama: podrás definir la anchura y altura en píxeles del diagrama.</li>
				<li>Tooltip: esta opción sólo estará habilitada para determinados tipos de gráficos. Si el tooltip está activo, puedes ver el valor del dato que representa un elemento de la gráfica pasando el ratón por encima.</li>
				<li>Tabla junto al diagrama: con esta opción activada, la tabla de datos se mostrará junto al diagrama para que puedas exportar ambas cosas juntas como HTML.</li>
			</ul>
	</section>

	
</body>

</html>
