/* Funciones para dibujar el diagrama y gestionar las opciones de diseño */

/* Declaramos la variables generales que usaremos */

var activeTable = 0;

var tooltip = false;

var width = 400, height = 300;

var type = "Line";

var theme = "graff";

var showTable = false;

/* Controlador de la opción del tooltip */
function toggleTooltip(){

	/* Sólo para type que lo acepten */
	
	tooltip = !tooltip;

	drawGraph();
	
}

/* Controlador del tamaño del diagrama */
function resizeGraph(side){
	 newWidth = document.getElementById("width");
	 newHeight = document.getElementById("height");
	
	/*Si el lado pasado como parámetro es la anchura, cambiamos la anchura. Si no,  la altura
	También establecemos un minimo de 100px*/
	 if (side=="width")
	{
		if (newWidth.value>100)
			width=newWidth.value;
		else
			newWidth.value=width=100;
	}
	 else
	{
		height=100
		if (newHeight.value>100)
			height=newHeight.value;
		else
			newHeight.value=wheight=100;
	}
		
	 drawGraph();
}

/* Controlador para mostrar/ocultar la tabla junto al diagrama */
function toggleTable(){
	showTable = !showTable;

	if(showTable){
		copyTable();
	}else{
		clearTable();
	}

}
function copyTable(){
	// Prevenimos la duplicidad de tablas
	clearTable();
	
	var box = document.getElementById("box_table");
	
	var newClass = ( theme != "37signals" ) ? theme : "signals";

	var table = document.getElementById("data_"+activeTable).cloneNode(true);
	table.setAttribute("id", "showData");
	table.setAttribute("ondblclick", "");
	table.setAttribute("class", newClass);
	box.appendChild(table);
}
function clearTable(){
	var box = document.getElementById("box_table");
	if(box.hasChildNodes())
		box.removeChild(box.firstChild);
}

/* Controlador para el tipo de diagrama*/
function typeGraph(newType){
	
	var allowsTooltip = document.getElementById(newType).getAttribute("data-tooltip"); 
	 if (allowsTooltip=="true")
		 document.getElementById("tooltip").disabled="";
	else
		document.getElementById("tooltip").disabled="true";
	
	type = newType;
	drawGraph();
}

/* Controlador para el theme del diagrama*/
function themeGraph(newTheme){
	theme = newTheme;
	
	// si motramos tabla, actualizamos su clase con el theme
	if(showTable){
		var newClass = ( theme != "37signals" ) ? theme : "signals";
		document.getElementById("showData").setAttribute( "class",  newClass);
	}
	drawGraph();
}

function drawGraph(){

	//Creamos el objeto Bluff dependiendo del tipo seleccionado y de los tamaños elegidos
	var g = eval("new Bluff."+type+"('graph', '"+width+"x"+height+"')");

	//Cargamos el theme seleccionado
	eval("g.theme_"+theme+"();")
		

	//Tomamos los datos de la tabla
	g.data_from_table('data_'+activeTable);

	//Cargamos el tooltip si está selecionado
	g.tooltips = tooltip;

	//Dibujamos el diagrama
	g.draw();
}

/* Funcion auxiliar para obtener tabla activa */
function getActiveTable(){
	return getElementsByClass("active_table", "tablespace", "table")[0];
}
/* Intercambio de hojas de tabla */
function setActiveTable(tab, sheet, draw){
	// Actualizamos la variable de control
	activeTable = sheet;
	
	if(draw)// si es el evento de cambiar hoja redibujamos
		drawGraph();

	// Cambiamos el titulo con la tabla activa
	document.title = "Hoja "+sheet+" - Graff";

	// Desmarcamos la pestaña activa anterior
	getElementsByClass("active","sheets_tools", "li")[0].removeAttribute("class");
	//y marcamos la actual
	tab.setAttribute("class","active");

	// Ocultamos la tabla activa anterior
	getActiveTable().setAttribute("class","");
	// y mostramos la tabla de la hoja activa
	document.getElementById("data_"+sheet).setAttribute("class","active_table");
	
	// Obtenemos posicion de las cabeceras
	positionHeads = getActualHeads();
	
	//Si está activo showTable, mostramos la nueva
	if(showTable)
		copyTable();
}

/* Controlador de conflictos */
function haveConflict(){
	/* Buscamos errores */
	checkError();
	var conflicts = getElementsByClass("conflict");
	if(conflicts.length > 0){
		document.getElementById("fixConflicts").setAttribute("class", "edition_context");
		var tab_sheets = document.getElementById("sheets_tools").getElementsByTagName("li");
		// Inicializamos controlador de primera hoja con conflicto con el numero de hojas
		var first_sheet = tab_sheets.length;
		// Buscamos primera hoja afecta
		for(var i = 0;  i < conflicts.length; i++){
			var c = conflicts[i];
			
			//la tabla esta tres niveles por encima
			var table = c.parentNode.parentNode.parentNode;
			
			// Extraemos numero de hoja actual
			var actual_sheet = new Number( table.getAttribute("id").split("_").pop() );
			// Seleccionamos si es menor que la hoja con conflicto actual
			first_sheet = (first_sheet < actual_sheet) ? first_sheet : actual_sheet;
			
			// Si es la hoja 0 ya no podemos esperar una menor
			if(first_sheet == 0)
				break;
		}
		// Activamos la primera hoja afecta
		setActiveTable(tab_sheets[first_sheet], first_sheet);
		// mostramos tablespace completo
		toggleWorkspace("tablespace");
		// y mostramos contexto de edición
		showEditionContext();
		
	}else{
		/* Se dibuja el diagrama */
		document.getElementById("fixConflicts").setAttribute("class", "edition_context_hidden");
		drawGraph();
	}
	
	
}
/* Marcar conflictos al guardar contexto edición */
function markConflict(table){	
	
	// Inicializamos variable de conflictos
	var conflicts = false;
	// y vaciamos div de errores
	document.getElementById("error").innerHTML = "";
	// Variable para controlar el número máximo de celdas encontradas
	prev_cols_found = 0;
	// Extraemos numero de hoja actual
	var actual_sheet = new Number( table.getAttribute("id").split("_").pop() );

	for( var i = 0, lr = table.rows.length; i < lr; i++ ){
	
		var row = table.rows[i];
		
		var lc = row.cells.length
	
		for( var j = 0; j < lc; j++ ){
		
			var cell = row.cells[j];
			
			if( cell.nodeName == "TH"){//tratamos según tipo de celda
				if( cell.firstChild != null && cell.firstChild.nodeValue != null ){
			
					var content = cell.firstChild.nodeValue.trim();
		
					if( content == "" && ( !( i == 0 && j == 0 ) || positionHeads == "col" ) ){// está vacía y no estamos en la esquina superior izquierda en modo head fila-columna
						// Lanzamos conflicto de cabecera vacía
						conflicts = true;
						// y marcamos celda
						cell.setAttribute("class", "conflict");
						cell.innerHTML=cell.innerHTML().replace("><",">0<");
					}else{
						// Desmarcamos celda por si estubiera marcada anteriormente
						cell.removeAttribute("class");
					}
				}else{
					if( ( !( i == 0 && j == 0 ) || positionHeads == "col" ) ){// está vacía y no estamos en la esquina superior izquierda en modo head fila-columna
						// Lanzamos conflicto de cabecera vacía
						conflicts = true;
						// y marcamos celda
						cell.setAttribute("class", "conflict");
					}
				}
			
			}else{
				
				if( cell.firstChild != null && cell.firstChild.nodeValue != null ){
				
					var content = cell.firstChild.nodeValue.trim();
			
					if( content == "" ){// si esta vacía
						// Lanzamos conflicto de celda vacía
						conflicts = true;
						// y marcamos celda
						cell.setAttribute("class", "conflict");
					}else if( content.match(/[a-zA-Z€$%]/) ){// si es texto
						// Lanzamos conflicto de texto en mitad de la tabla
						conflicts = true;
						// y marcamos celda
						cell.setAttribute("class", "conflict");
					}else{
						// Desmarcamos celda por si estubiera marcada anteriormente
						cell.removeAttribute("class");
					}
			
				}else{
					// Lanzamos conflicto de celda vacía
					conflicts = true;
					// y marcamos celda
					cell.setAttribute("class", "conflict");
				}
			}
			
		}
		
		// Controlamos número de celdas
		if( i > 0 && prev_cols_found != lc ){// si no estamos en la primera fila y las celdas de la actual son diferentes a las anteriores
			// Lanzamos conflicto de fila con distinto numero de celdas
			conflicts = true;
			// y marcamos primera celda
			row.firstChild.setAttribute("class", "conflict");
		}else{//si no salvamos numero  de celdas para siguiente iteracion
			prev_cols_found = lc;
		}
		
	}
	
	if( !conflicts )// sino hay conflictos
		return false;
	else{// si los hay
		document.getElementById("error").innerHTML = "Existen errores en algunas de las hojas. Están marcados en rojo y podrá corregirlos en el Contexto de Edición que se abrirá automáticamente.";
		return true;
	}
	
	
}
/* Controladores de herramientas */

/* Cambiar de workspace */
function toggleWorkspace(showWorkspace){
	var graphspace = document.getElementById("graphspace");
	var tablespace = document.getElementById("tablespace");
	
	if( showWorkspace == "tablespace" ){
		tablespace.className = "workspace";
		graphspace.className = "inactive";
	}else{
		tablespace.className = "inactive";
		graphspace.className = "workspace";
	
		/* Redibujamos el diagrama ahora que el graphspace es visible */
		drawGraph();
	}
}
/* Compartir vista ambos workspace */
function shareWorkspace(){
	var graphspace = document.getElementById("graphspace");
	var tablespace = document.getElementById("tablespace");
	
	tablespace.className = "share";
	graphspace.className = "share";
	
	/* Redibujamos el diagrama ahora que el graphspace es visible */
	drawGraph();
}

/* Contexto de edición */
var oldSaveTable = null;

/* Mostramos contexto de edición */
function showEditionContext(){
	
	var table = getActiveTable();
	// Guardamos copia de la tabla
	oldSaveTable = table.cloneNode( true ); // Clonamos la tabla con todo sus elementos
	
	// Hacemos editable la tabla activa
	table.setAttribute("contentEditable", "true");
	table.setAttribute("class", table.getAttribute("class")+" edition_table");
	table.setAttribute("ondblclick", "");
		
	// Añadimos herramientas de edición
	table = addEditionTools(table);
	
	// Mostramos herramientas generales del contexto de edicion
	var toolsEdition = getElementsByClass("edition_context", table.getAttribute("id"), "table");
	for(var i = 0, l = toolsEdition.length; i < l; i++){
		toolsEdition[i].style.display = "inline";
	}
	// y ocultamos las del contexto de vision
	var toolsView = getElementsByClass("view_context", table.getAttribute("id"), "table");
	for(var i = 0, l = toolsView.length; i < l; i++){
		toolsView[i].style.display = "none";
	}
	
	// Deshabilitamos el resto de herramientas y botones
	document.getElementById("bottomTools").style.display = "block";
	document.getElementById("topTools").style.display = "block";
}
/* Refrescamos diagrama con los datos del contexto de edición */
function refreshEditionContext(){

	// Seleccionamos la tabla activa
	var table = getActiveTable();
	
	// Borramos herramientas de edición
	delEditionTools(table);
	
	// Redibujamos diagrama tras la edición
	drawGraph();
	//Si está activo showTable, mostramos la tabla actualizada
	if(showTable)
		copyTable();
	
	// Añadimos herramientas de edición
	addEditionTools(table);
	
}

/*Rellenamos los conflictos con ceros*/
function fixConflicts(){
	
	/*Seleccionamos celdas con conflictos*/
	var conflicts = getElementsByClass("conflict");
	var l = conflicts.length;
	for(var i = l-1;  i >= 0; i--){
		var c = conflicts[i];
		// Rellenamos con un 0
		c.innerHTML = 0;
		// y eliminamos la clase que marca la celda con conflicto
		c.removeAttribute("class");
	}
	
}

/* Salimos del contexto de edición guardando datos */
function saveEditionContext(){

	// Seleccionamos la tabla activa
	var table = getActiveTable();
	
	//  Quitamos herramientas de edición
	table = delEditionTools(table);
	
	// Marcar conflictos de datos después de la edición
	var conflict = markConflict(table);
	
	
	if(conflict){// Si hay conflictos
		// lanzamos gestor 
		haveConflict();
	}else{// sino cerramos contexto de edicion
		
		table.setAttribute("contentEditable", "false");	
		table.setAttribute("ondblclick", "showEditionContext()");
		
		// Ocultamos herramientas generales del contexto de edicion
		var toolsEdition = getElementsByClass("edition_context", table.getAttribute("id"), "table");
		for(var i = 0, l = toolsEdition.length; i < l; i++){
			toolsEdition[i].style.display = "none";
		}
		// y mostramos las del contexto de vision
		var toolsView = getElementsByClass("view_context", table.getAttribute("id"), "table");
		for(var i = 0, l = toolsView.length; i < l; i++){
			toolsView[i].style.display = "inline";
		}
	
		// Redibujamos diagrama tras la edición
		drawGraph();
	
		//Si está activo showTable, mostramos la tabla actualizada
		if(showTable)
			copyTable();
		
		// Habilitamos el resto de herramientas y botones
		document.getElementById("bottomTools").style.display = "none";
		document.getElementById("topTools").style.display = "none";
		
		// Comprobamos si hay conflictos en otras hojas
		haveConflict();
	}
}
/* Salimos del contexto de edición sin guardar datos */
function exitEditionContext(){

	// Seleccionamos la tabla activa
	var table = getActiveTable();
	
	
	
	// Marcamos conflictos de datos en la versión antigua de la tabla
	var conflict = markConflict(oldSaveTable);
	
	
	// Reemplazamos la tabla activa por la guardada sin editar
	table.parentNode.replaceChild(oldSaveTable, table);
	
	if(conflict){// Si hay conflictos
		// lanzamos gestor 
		haveConflict();
	}else{// sino cerramos contexto de edicion

		table.setAttribute("contentEditable", "false");	
		table.setAttribute("ondblclick", "showEditionContext()");
	
		// Ocultamos herramientas generales del contexto de edicion
		var toolsEdition = getElementsByClass("edition_context", table.getAttribute("id"), "table");
		for(var i = 0, l = toolsEdition.length; i < l; i++){
			toolsEdition[i].style.display = "none";
		}
		// y mostramos las del contexto de vision
		var toolsView = getElementsByClass("view_context", table.getAttribute("id"), "table");
		for(var i = 0, l = toolsView.length; i < l; i++){
			toolsView[i].style.display = "inline";
		}
	
		// Redibujamos diagrama tras la edición
		drawGraph();
	
		//Si está activo showTable, mostramos la tabla actualizada
		if(showTable)
			copyTable();
		
		// Habilitamos el resto de herramientas y botones
		document.getElementById("bottomTools").style.display = "none";
		document.getElementById("topTools").style.display = "none";
	}
}

/* Montaje de herramientas de edición */
function addEditionTools(table){ 
	// Insertamos herramientas por filas (primera celda de cada fila, menos cabeceras)
	for(var i = 0;  i < table.rows.length; i++){
		var cell = table.rows[i].insertCell(0);
		cell.setAttribute("class", "edition_tool");
		cell.setAttribute("contentEditable", "false");
		if(positionHeads == "col" || i >= 1 )//evitamos herramientas en la primera celda si es cabecera
			cell.innerHTML = getRowTools();
	}
	// Insertamos herramientas por columnas (tantas celdas como la mayor fila, menos herramientas y cabeceras)
	var row = table.insertRow(0);
	row.setAttribute("class", "edition_tool");
	row.setAttribute("contentEditable", "false");
	var l = maxNumCells(table);
	for(var i = 0;  i < l; i++){
		var cell = row.insertCell(i);
		if(i >= 2)//evitamos herramientas en las dos primeras celdas
			cell.innerHTML = getColTools();
	}
	
	// Insertamos herramientas en los extremos, sólo añadir fila/columna
	// Última celda de la primera fila, insertar col
	var endCell = row.insertCell( row.cells.length );
	endCell.innerHTML = getAddCol();
	// Primera celda en la última fila, insert row
	var endRow = table.insertRow( table.rows.length );
	endRow.setAttribute("class", "edition_tool");
	endRow.setAttribute("contentEditable", "false");
	var auxCell = endRow.insertCell(0);
	auxCell.innerHTML = getAddRow();
	
	return table;
}
/* Desmontaje de herramientas de edición */
function delEditionTools(table){
	
	for(var i = 0, l = table.rows.length;  i < l; i++){
		// Recorremos por filas
		var row = table.rows[i];
		// si la fila no es edition_tool
		if(row.getAttribute("class") != "edition_tool"){
			// buscamos las primera celda
			var cell = row.cells[0];
			// si la celda es edition_tool
			if(cell.getAttribute("class") == "edition_tool")
				cell.parentNode.removeChild(cell);
		}else{ //sino, borramos fila
			row.parentNode.removeChild(row);
			//controlamos la eliminacion de filas
			i--;
			l--;
		}
	}
	
	return table;
}
/* Funcion auxiliar para encontrar el mayor numero de celdas por fila */
function maxNumCells( table ){

	var maxNum = 0;

	for( var i = 0, r = table.rows.length; i < r; i++ ){
	
		var cellsRow = table.rows[i].cells.length;
		
		maxNum = ( maxNum > cellsRow )? maxNum : cellsRow;
		
	}

	return maxNum;

}

/* Funciones auxiliares de montaje de herramientas de edición */
function getRowTools(){
	var tools = getAddRow() + getDelRow();
	return tools;
}
function getColTools(){
	var tools = getAddCol() + getDelCol();
	return tools;
}

function getAddRow(){
	return '<span class="add_row" onclick="addRow(this.parentNode.parentNode.rowIndex)" onmouseover="focusAddRow(this.parentNode.parentNode.rowIndex)" onmouseout="blurAddRow(this.parentNode.parentNode.rowIndex)">+</span>';
}
function getDelRow(){
	return '<span class="del_row" onclick="delRow(this.parentNode.parentNode.rowIndex)" onmouseover="focusDelRow(this.parentNode.parentNode.rowIndex)" onmouseout="blurDelRow(this.parentNode.parentNode.rowIndex)">x</span>';
}
function getAddCol(){
	return '<span class="add_col" onclick="addCol(this.parentNode.cellIndex)" onmouseover="focusAddCol(this.parentNode.cellIndex)" onmouseout="blurAddCol(this.parentNode.cellIndex)">+</span>';
}
function getDelCol(){
	return '<span class="del_col" onclick="delCol(this.parentNode.cellIndex)" onmouseover="focusDelCol(this.parentNode.cellIndex)" onmouseout="blurDelCol(this.parentNode.cellIndex)">x</span>';
}

/* Funciones para evento focus y blur de herramientas de edición */
function focusAddRow(r){
	// Seleccionamos tabla activa
	var table = getActiveTable();

	// Insertamos la fila auxiliar en la posición r
	var newRow = table.insertRow( r );
	
	for(var i = 0, l = table.rows[0].cells.length; i < l-1; i++){
		var newCell = newRow.insertCell(i);
		newCell.setAttribute("class", "focusAdd");
	}
	newRow.firstChild.setAttribute("class", "edition_tool");
}
function blurAddRow(r){
	var table = getActiveTable();
	// Seleccionamos elementos de la clase focusAdd
	var focus = getElementsByClass("focusAdd", table.getAttribute("id"), "td");
	// Borramos el tr donde esté la primera celda de la clase focusAdd
	focus[0].parentNode.parentNode.removeChild(focus[0].parentNode)
	/*for(var i = 0, l = focus.length;  i < l; i++){
		focus[i].parentNode.removeChild(focus[i]);
	}*/
}
function focusDelRow(r){
	// Seleccionamos fila r y la marcamos
	var table = getActiveTable();
	table.rows[r].setAttribute("class", "focusDel");
}
function blurDelRow(r){
	var table = getActiveTable();
	if(table.rows[r].getAttribute("class") == "focusDel"){// Gestionar blur después de eliminar columnas
		// Seleccionamos fila r y la desmarcamos
		table.rows[r].removeAttribute("class");
	}
}
function focusAddCol(c){
	// Seleccionamos tabla activa
	var table = getActiveTable();

	// Recorremos todas las filas (el número de filas lo marca las herramientas)
	for(var i = 0, l = table.rows.length;  i < l; i++){
		var newCell = document.createElement("TD");
		newCell.setAttribute("class", "focusAdd");
		// insertamos la celda auxiliar antes de la posición de la celda c
		table.rows[i].insertBefore(newCell, table.rows[i].cells[c] );
	}
	
}
function blurAddCol(c){
	var table = getActiveTable();
	// Eliminamos elementos de la clase focusAdd
	var focus = getElementsByClass("focusAdd", table.getAttribute("id"), "td");
	for(var i = focus.length-1;  i >= 0; i--){
		focus[i].parentNode.removeChild(focus[i]);
	}
}
function focusDelCol(c){
	// Seleccionamos col c y la marcamos
	var table = getActiveTable();
	for(var i = 1, l = table.rows.length-1;  i < l; i++){
		if( table.rows[i].cells[c] ){
			var cell = table.rows[i].cells[c];
			var auxClass = cell.getAttribute("class");
			cell.setAttribute("class", auxClass+" focusDel");
		}
	}
}
function blurDelCol(c){
	if(c!=0){// Gestionar blur después de eliminar columnas
		// Seleccionamos col c y la desmarcamos
		var table = getActiveTable();
		for(var i = 1, l = table.rows.length-1;  i < l; i++){
			if( table.rows[i].cells[c] ){
				var cell = table.rows[i].cells[c];
				var auxClass = cell.getAttribute("class").replace(" focusDel", "");
				cell.setAttribute("class", auxClass);
				
			}
		}
	}
}

/* Inserción de filas */
function addRow(r){
	// Seleccionamos tabla activa
	var table = getActiveTable();

	// Insertamos la fila nueva en la posición r
	var newRow = table.insertRow( r );
	
	// Recorremos las celdas de la fila de control para mantener formato (el número de celdas lo marca la fila de herramientas)
	for(var i = 0, l = table.rows[0].cells.length; i < l-1; i++){
		// creamos la nueva celda
		if(i == 1)// Celda cabecera
			var newCell = document.createElement("TH");
		else// Celda normal		
			var newCell = document.createElement("TD");

		// insertamos la nueva celda en la nueva fila
		newRow.appendChild(newCell);
	}
	
	// Añadimos las herramientas de edición en la primera celda de la fila
	newRow.firstChild.setAttribute("class", "edition_tool");
	newRow.firstChild.setAttribute("contentEditable", "false");
	newRow.firstChild.innerHTML = getRowTools();

}

/* Inserción de columnas */
function addCol(c){
	// Seleccionamos tabla activa
	var table = getActiveTable();

	// Recorremos todas las filas (el número de filas lo marca las herramientas)
	for(var i = 0, l = table.rows.length;  i < l-1; i++){
		// creamos la nueva celda
		if( positionHeads == "both" && i==1 )//está marcada fila como cabecera
			var tn = "TH";		
		else//no está marcada fila como cabecera o no se sabe
			var tn = "TD";
			
		var newCell = document.createElement(tn);
		// insertamos la nueva celda antes de la posición de la celda c
		table.rows[i].insertBefore(newCell, table.rows[i].cells[c] );
	}
	
	// Añadimos las herramientas de edición en la celda de la primera fila
	table.rows[0].cells[c].setAttribute("class", "edition_tool");
	table.rows[0].cells[c].setAttribute("contentEditable", "false");
	table.rows[0].cells[c].innerHTML = getColTools();
}

/* Eliminación de filas */
function delRow(r){
	// Seleccionamos tabla activa
	var table = getActiveTable();
	
	// eliminamos la fila "r"
	table.deleteRow(r);
}

/* Eliminación de columnas */
function delCol(c){
	// Seleccionamos tabla activa
	var table = getActiveTable();

	// Recorremos todas las filas (menos la útlima que es sólo de herramienta)
	for(var i = 0, l = table.rows.length;  i < l-1; i++){
		// eliminamos la celda "c" si existe
		if( table.rows[i].cells[c] )
			table.rows[i].deleteCell(c);
	}
}

/* Marcar/desmarcar primera fila como cabecera */
var positionHeads = "";

function setHeads(position){

	// Seleccionamos tabla activa
	var table = getActiveTable();
	
	// Tipos de celdas, predeterminado tipo <td>
	var typeRowCell = "td", typeColCell = "td";
	
	/* Convertimos en <th> tipo de celda de fila */
	if( (position == "both"))
		typeRowCell = "th";
		
	/* Convertimos en <th> tipo de celda de columna */
	if( (position == "col") || (position == "both"))
		typeColCell = "th";

	// Extraemos fila
	var row = table.rows[0];
	
	// Transformamos las celdas de la primera fila
	for(var i = 1, l = row.cells.length; i < l; i++){
		// creamos la nueva celda
		var newCell = document.createElement(typeRowCell);
		// extraemos celda antigua
		var oldCell = row.childNodes[i];
		// volcamos dato de la celda antigua a la nueva
		newCell.innerHTML = oldCell.innerHTML;
		// reemplazamos nodo antiguo por el nuevo
		row.replaceChild(newCell, oldCell);
	}

	// Transformamos las celdas de la primera columna
	for(var i = 1, l = table.rows.length; i < l; i++){
		// creamos la nueva celda
		var newCell = document.createElement(typeColCell);
		// extraemos celda antigua
		var oldCell = table.rows[i].firstChild;
		// volcamos dato de la celda antigua a la nueva
		newCell.innerHTML = oldCell.innerHTML;
		// reemplazamos nodo antiguo por el nuevo
		table.rows[i].replaceChild(newCell, oldCell);
	}
	
	// Conservamos valor en variable global
	positionHeads = position;

	// Redibujamos el diagrama
	drawGraph();

}

function getActualHeads(){
	// Seleccionamos tabla activa
	var table = getActiveTable();
	
	// extraemos el tipo de la segunda celda de la primera fila
	var type = table.rows[0].cells[1].nodeName;
	
	if( type == "TH")
		return "both";
	else
		return "col";
	
}
