/*Funciones de validación de datos*/

function showLoaderChecking(){
	document.getElementById("checkingKey").style.display='block';
}

function hideLoaderChecking(){
	document.getElementById("checkingKey").style.display='none';
}


/* Validación automática al escribir un key o dirección de Google Docs  */
function autoValKey(input){



	var googleName = input.value;

	if( googleName != "" ){ //Comprobación para descartar el borrado de inputs
	
		showLoaderChecking();

		var key = valKey(googleName);
	
		if( key ){

			/* Comprobación de si el key existe y el documento es público, recibimos título en caso de éxito */

			ajax=newAJAX(); 
			ajax.open("GET", "php/checkSpreadSheet.php?key="+key, true); 

			ajax.onreadystatechange=function(){
				if(ajax.readyState==1){
					//Sucede cuando se esta cargando la pagina
				}else if(ajax.readyState==4){
					//Sucede cuando la pagina se cargó
					if(ajax.status==200){
						//Todo OK
						title = ajax.responseText;
						if ( title != "" && title != 0 ){
							/* Guardamos en el input el valor adecuado del key */
							input.value = key;

							/* Ocultamos campos formulario y mostramos icono de Google SpreadSheets junto al título del documento */
							showUploadInfo(title, 'gss');

						}else{
							/* Devolvemos mensaje de error y vaciamos el input */
							input.value = "";
							hideLoaderChecking();
							openPopup("Documento Google SpreadSheet", "El documento no existe o no es público. Mira en el FAQ cómo hacerlo público.");
						}

					}else if(ajax.status==404){
						//La pagina no existe
						hideLoaderChecking();
						openPopup("Error en la comunicación AJAX", "Ha ocurrido mientras se realizaba la comprobación mediante AJAX. <br/>Vuelva a intentarlo o comuníquese con info@html5graff.es");
					}else{
						//Mostramos el posible error
						hideLoaderChecking();

						openPopup("Error en la comunicación AJAX", "Error: "+ajax.status+"<br/>Vuelva a intentarlo o comuníquese con info@html5graff.es");
					}
				}
			}

			ajax.send(null);


		}else{
			/* Devolvemos mensaje de error y vaciamos el input */

			input.value = "";

			openPopup("Documento Google SpreadSheet", "La información introducida no es una URL correcta o el key no es válido");
		}
	}

}

/* Validación del key de Google Docs*/
function valKey(value){

	var expRegURL = /(http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/;
	var expRegGoogleDoc = /(spreadsheets)[0-9]?(\.google\.com\/)/;

	var key = 0;
	/* Comprobamos si es una URL */
	if( value.match(expRegURL) ){
		/* Comprobamos si es de Google SpreadSheets */
		if( value.match(expRegGoogleDoc) ){
			/* Depuramos la posible aparición de "autokey" en la URL */
			value = value.replace("autokey", "");
			/* Extraemos el key*/
			key = ( value.split("key=") ).pop();
			key = ( key.split("&") ).shift();
		}
	}else{
		/* Copiamos directamente el valor del campo */
		key = value;
	}
	
	return key;
	
}



/* Validación automática de la extensión del archivo seleccionado   */
function autoValExtension(input){

	var fileName = input.value;

	if( fileName != "" ){ //Comprobación para descartar el borrado de inputs

		var ext = valExtension(fileName);
	
		if( ext ){

			/* Ocultamos campos formulario y mostramos icono de Google SpreadSheets junto al título del documento */
			showUploadInfo(input.value.slice(0,-4), ext);

		}else{
			/* Devolvemos mensaje de error y vaciamos el input */

			input.value = "";

			openPopup("Tipo de fichero incorrecto", "Por favor, seleccione un fichero con extensión .ods, .xls, .csv o .txt");	
		}

	}

}

/* Validación de la extensión del fichero a subir */
function valExtension(fileName){
	
	var acceptedExtensions = ["xls", "ods", "txt", "csv"];
	var extension=(fileName.split(".")).pop();
	
	for(ext in acceptedExtensions)
	{	
		if (acceptedExtensions[ext]==extension) 
			return extension;
	}
	
	return 0;
}

/* Validación de la fuente de datos*/
function valData(){
	
	var result=false;
	
	var fileName=document.getElementById("data_from_file").value;
	var googleName=document.getElementById("data_from_google").value;
	 
	 /*Chequea que no estén ambas fuentes vacías*/
	if (fileName=="" && googleName=="")
	{
		openPopup("Error de selección de fichero", "No ha seleccionado ninguna fuente de datos");
	}
	
	/*Chequea que no estén ambas fuentes rellenas*/
	else if 
	(fileName!="" && googleName!="")
	{
		openPopup("Error de selección de fichero", "Seleccione sólo una fuente de datos");
	}
	
	/*Chequea que el tipo de fichero seleccionado sea correcto y redirecciona*/
	else
	{
		result=true;
		
		if (fileName!="")
		{
			var fileType=valExtension(fileName);
					
				document.getElementById("form_data").action="php/readDataFromFile.php";
		}
		else{
			if(valKey(googleName))
				document.getElementById("form_data").action="php/readDataFromGSS.php";
			else
				result=false;
		}
			
	}
	
	if(result){
		return true;
	}else{
		
		openPopup("Error no identificado", "Ha ocurrido algún error en el envío de los datos, revise los datos introducidos");
	}
}
