<?php


class GoogleSpreadSheets {
	
	static private $worksheets;

	public static function getFileData($key) {
		$dom = new DOMDocument('1.0', 'utf-8');
		$dom->validateOnParse = true;

		// Leemos feed de worksheets
		if(! GoogleSpreadSheets::$worksheets = @file_get_contents ( "https://spreadsheets.google.com/feeds/worksheets/".$key."/public/values" ))
				throw new Exception();

		// Cargamos XMl
		$dom->loadXML( GoogleSpreadSheets::$worksheets );
		
		// Extraemos el título
		$_SESSION['title'] = GoogleSpreadSheets::getTitle();
		
		// Extraemos tag entry con cada worksheet
		$tags_entry = $dom->getElementsByTagName("entry");

		// Inicializamos array sheets
		$sheets = array();

		// Recorremos por las tags entry
		for ($i = 0, $l = $tags_entry->length; $i < $l; $i++){
			// Extraemos el ID de la entrada
			$id = array_pop( explode( "/", $tags_entry->item($i)->firstChild->nodeValue ) );

			// Leemos feed de cells
			if( $cells = file_get_contents ( "https://spreadsheets.google.com/feeds/cells/".$key."/".$id."/public/values" ) ){
				$dom2 = new DOMDocument('1.0', 'utf-8');
				$dom2->validateOnParse = true;
				// Cargamos XML
				$dom2->loadXML( $cells );
				// Extraemos tag entry con cada celda
				$cells_entry = $dom2->getElementsByTagName("entry");
				// Recorremos por las tags entry
				foreach ($cells_entry as $entry){
					// Cogemos último hijo (<gs:cell>)
					$item = $entry->lastChild;
					// Extraemos fila y columna
					$row = $item->attributes->getNamedItem("row")->nodeValue;
					$col =  $item->attributes->getNamedItem("col")->nodeValue;
					// y extraemos valor
					$value = $item->nodeValue;
					// Insertamos el valor de la celda en la posición correspondiente
					$sheets[$i][$row][$col] = $value;
				}
			}
		}
		return $sheets;
	}
	
	public static function getTitle($key = false) {

			try{
				if( $key )// Leemos feed de worksheets si no está leído ya
					if(! GoogleSpreadSheets::$worksheets = @file_get_contents ( "https://spreadsheets.google.com/feeds/worksheets/".$key."/public/values" ))
						throw new Exception();
						
						
				$dom = new DOMDocument('1.0', 'utf-8');
				$dom->validateOnParse = true;
			
				if(! $dom->loadXML( GoogleSpreadSheets::$worksheets ) )
					throw new Exception();
					
				// Extraemos tag title
				$tags = $dom->getElementsByTagName("title");
				
				if(count($tags) == 0)
					throw new Exception();
					
				$title  = $tags->item(0)->nodeValue;
			
				return $title;
				
			}catch(Exception $e){
				return 0;
			}
	}
	private function getAttribute($name, $att){
    	foreach($att as $i){
	        if($i->name()==$name)
    	        return $i->value();        
    	}
	}
	
}
?>
