<?php
	/*
	Este controlador extrae los datos de entrada desde un archivo y los transforma en la tabla estandar para graff
	*/
	session_start();
	
	if( isset($_SESSION['sheets']) ){
		// Recogemos datos de las variables de sesión
	
		$sheets =  $_SESSION['sheets'];
		$title = $_SESSION['title'];

		$_SESSION["data_table"] = array();

		// Recorremos las hojas
		$sheets_found = 0;//contador de hojas válidas
	
		// Inicializamos el contenedor de errores
		$errors = false;

		foreach ($sheets as $sheet){
			// Recorremos la hoja si tiene filas
			if( count($sheet) > 0 ){	
			
				// Inicializamos variable table			
				if($sheets_found==0)
					$table = '<table id="data_'.$sheets_found.'" ondblclick=showEditionContext() class="active_table">';
				else
					$table = '<table id="data_'.$sheets_found.'" ondblclick=showEditionContext()>';

				// Ponemos el tiutlo en el caption
				$table .= '<caption>'.$title.' - Hoja '.$sheets_found.'</caption>';
				
				// Inicializamos variable de control de filas encontradas
				$rows_found = 0;
				// y la variable para controlar el número máximo de celdas encontradas
				$prev_cols_found = 0;
				
				foreach ($sheet as $keyRow => $row){
					// Inicializamos contenido de la fila
					$content_row = "";
					
					// Inicializamos variable de control de celdas encontradas
					$cols_found = 0;
					
					// Recorremos celdas
					foreach ($row as $keyCell => $cell ){
						
						$content = @iconv("UTF-8", "ASCII//IGNORE", $cell);

						if ( $content === 0 || !empty( $content )){
							if ( /* por primera vez en la fila */!$cols_found ||
								/* o no se ha encontrado la primera fila aún*/( !$rows_found &&
								 /* y es texto */preg_match("/[a-zA-Z€$%]/", $content) ) ){
								 
								// es cabecera
								$content_row .= "<th>".$content."</th>";
								
							}else{
								if( preg_match("/[a-zA-Z€$%]/", $content) ){
									// si es texto en medio de la tabla, conflicto
									$content_row .= "<td class='conflict'>".$content."</td>";
									
									// Lanzamos conflicto
									$errors = true;
								}else{
									// sino, es dato normal
									$content_row .= "<td>".$content."</td>";
								}
							}
							// Hemos encontrado una celda
							$cols_found++;
							
						}else{

							// Encuentra celdas vacías en medio de la tabla
							if ( $rows_found && $cols_found ){
								// Rellenamos hueco
								$content_row .= "<td class='conflict'>0</td>";
								// Hemos encontrado una celda, aunque en este caso esté vacía
								$cols_found++;
								
								// Lanzamos conflicto
								$errors = true;
							}else{
								// Si no se han encontrado ni celdas ni columnas aún, encuentra celdas vacías
								// en la esquina superior izquierda de cabeceras por fila y columna
								if( !empty( $sheet[ $keyRow+1 ][ $keyCell ] ) &&// si hay contenido en la misma posición de la siguiente fila
									!empty( $sheet[ $keyRow ][ $keyCell+1 ] ) ){ // y en la siguiente celda de la misma fila
									
									// Rellenamos hueco
									$content_row .= "<th> </th>";

									// Hemos encontrado una celda, aunque en este caso esté vacía
									$cols_found++;
								}
								
							}

						}

					}
					
					if($cols_found){// si se ha encontrado al menos una celda
					
						if($rows_found && // No es la primera fila
							($cols_found != $prev_cols_found) ){ // y se ha encontrado un número diferente de celdas
							// Añadimos tantas celdas vacías al final de la fila como diferencia haya
							for ($i = 0, $l = $prev_cols_found - $cols_found; $i < $l; $i++){
								$content_row .= "<td class='conflict'>0</td>";
							}
							// Lanzamos conflicto
							$errors = true;
							//	escribimos el contenido de la fila, marcando el conflicto
							$table .=  "<tr>".$content_row."</tr>";
						}else{
							//	escribimos el contenido de la fila
							$table .=  "<tr>".$content_row."</tr>";
						}
						// salvamos el número de columnas mayor
						$prev_cols_found = max($prev_cols_found, $cols_found);
						
						// y marcamos que ya hemos encotrado la primera
						$rows_found++;
					}
						
				}
				
				if($rows_found){//si la hoja no está vacía
					$table .= '</table>';
					
					$_SESSION["data_table"][$sheets_found] = $table;

					$sheets_found++;//aumentamos el contador de hojas
					
				}

			}
		}
		if($errors)
			$_SESSION["errores"] = "Existen errores en algunas de las hojas. Están marcados en rojo y podrá corregirlos en el Contexto de Edición que se abrirá automáticamente.";

		header("Location: ../options.php");
		
	}else{
		// Devolvemos error a la página index 

		$_SESSION["errores"] = "La sesión ha expirado o ha ocurrido un error no manejado.";
		header("Location: ../index.php");


	}

?>
